/* R-U-ON Vista Gadget           */
/* Copyright (c) 2007 R-U-ON LLC */
/* www.r-u-on.com                */

// Consts
var gadgetTitle = {
    "alarms":"Alarms",
    "agents":"Agents",
    "tickets":"Track Tickets"
};
var dataPanels = ["zeroalarms", "zeroagents", "zerotickets", "errordisplay", "welcome", "datapanel"];
var renderFields = [{
    "agents": [ ["Agent", -1], ["Type", 55, "right"] ],
    "alarms": [ ["Agent", 65], ["Resource", -1, "right"]],
    "tickets": [ ["TRK#", 30], ["Opened By Trunc", -1, "right"]]
}, {
    "agents": [ ["Agent", -1], ["Type", 100], ["IP",100], ["State", 40] ],
    "alarms": [ ["Agent", 100], ["Resource", -1], ["Time Up", 140, "right"] ],
    "tickets": [ ["TRK#", 30], ["Opened At", 100], ["Opened By", 120, "left"], ["Category", -1, "right"]  ]
}];

var sizes = [
    { "datapanel": {"width":111, "height":104},
      "thecontainersite": {"width":111, "widthScroll":104, "height":104},
      "thecontainer":{"width":111, "widthScroll":104, "height":104},
      "thetable":{"width":111, "widthScroll":104}
    },{
      "datapanel": {"width":381, "height":184},
      "thecontainersite": {"width":381, "widthScroll":374, "height":184},
      "thecontainer":{"width":381, "widthScroll":374, "height":184},
      "thetable":{"width":381, "widthScroll":374}
    }];

// Globals
var authTimer = null;
var authId = 0;
var authText = ["Logging in...", "Logging in", "Logging in.", "Logging in.."]
var refreshTimer = null;
var thedata = null;
var selectedTr = null;
var scrollbar = null;
var minimal = false;

function init() {
    System.Gadget.settingsUI = "settings.html";
    System.Gadget.onSettingsClosed = settingsClosed;
    System.Gadget.Flyout.onHide = function() { selectRow(null); }; 
    
    System.Gadget.onDock = dockChange;
    System.Gadget.onUndock = dockChange;
    
    minimal = System.Gadget.Settings.read("minimal")=="yes";
    
    setPageSize();
    
    refresh();
}

function giant() {
    return !(System.Gadget.docked || minimal);
}

function setPageSize(scroll) {
    if (giant())  {
        pageSize(400,230);
    } else {
        pageSize(130,150);
    }
    document.getElementById("minmax").src = minimal?"img/maximize.png":"img/minimize.png";
    document.getElementById("minmax").style.display = System.Gadget.docked?"none":"";
}

function minmax() {
    minimal = !minimal;
    System.Gadget.Settings.write("minimal", minimal?"yes":"no");
    document.getElementById("minmax").blur();
    setPageSize();
    if (thedata!=null)  {
        setTimeout("render()", 100);
    }
  
}

function dockChange() {
    setPageSize();
    if (thedata!=null) {
       render();
    }
}


function status(s) {
    if (s) {
        statusBar.innerText = s;
    } else {
        statusBar.innerHTML = "&nbsp;";
    }
}

function settingsClosed() {
    var password =  System.Gadget.Settings.read("PASSWORD");
    if (password!="") {
        var username = System.Gadget.Settings.read("USERNAME");
        System.Gadget.Settings.write("PASSWORD", "");
        animAuth();
        authenticate(username, password, authResult);
    } else {
        refresh();
    }
}

function authResult(good, s) {
    stopAnimAuth();
    if (good) {
        System.Gadget.Settings.write("UID", s);
        status("Logged in.");
        refresh();
    } else {
        status(s);
        refresh();
    }
}

function animAuth() {
    status(authText[authId%authText.length]);
    authId++;
    authTimer = setTimeout("animAuth()",250);
}

function stopAnimAuth() {
    clearTimeout(authTimer);
}

function refresh() {
    var uid = System.Gadget.Settings.read("UID");
    if (uid=="") {
        showPanel("welcome");
        return;
    }
    
    var mode = System.Gadget.Settings.read("MODE");
    if (mode=="") {
        mode = "alarms";
    }

    title.innerText = gadgetTitle[mode];
    status("Loading...");
    
    fetchData(uid, mode, false, onData);
}

function showPanel(panel) {
    for (var i=0;i<dataPanels.length;++i) {
        document.getElementById(dataPanels[i]).style.display = "none";
    }
    document.getElementById(panel).style.display = "";

}

function showError(e) {
    errortext.innerHTML = e;
    showPanel("errordisplay");
    status();
}

function setNextRefresh(ttl) {
    if (refreshTimer!=null) {
        clearTimeout(refreshTimer);
    }
    refreshTimer = setTimeout("refresh()", ttl*60*1000);
}


function onData(data) {
    thedata = null;
    if (data.type=="exception") {
        showError("<b>"+data.title+"</b><br>"+data.description);
        setNextRefresh(15);
    } else {
        setNextRefresh(data.ttl);
        status("Updated "+nowString());
        if (data.rows.length==0) {
            showPanel("zero"+data.type);            
            return;
        } else {
            thedata = data;
            showPanel("datapanel");
            render();
        }
    }
}

function nowString() {
    var theDate = new Date();
    var theHour = String(theDate.getHours());
    var theMinutes = String(theDate.getMinutes());
    if (theMinutes.length == 1)
        theMinutes = "0" + String(theMinutes);
    if ( theHour > 12 ) {
        theHour = String(theHour - 12);
        amPM = "PM";
    } else {
        amPM = "AM";
    }

    if ( theHour == 12 ) amPM = "PM";
    if ( theHour == 0 ) theHour = "12";

    return theHour + ":" + theMinutes + amPM;
}

function render() {
    while (thetable.rows.length>0) {
        thetable.deleteRow(0);
    }
    thecontainer.offsetWidth;
    thecontainer.offsetHeight;
    
    selectedTr = null;
    
    
    var fields = renderFields[giant()?1:0][thedata.type];
    var group = (giant()) && thedata.type=="agents";
    var agroup = "None";
    
    sizeRow(fields);
    var i=0;
    for (row in thedata.rows) {
        if (group && agroup!=thedata.rows[row]["Group"]) {
            agroup=thedata.rows[row]["Group"];
            createRow( {"Agent":agroup, "Title":agroup,"severity":"GroupRow","noselect":true} ,fields);
        }
        createRow(thedata.rows[row], fields, i++);
    }
    document.body.focus();
    doResize();
    //setTimeout("scroller();scroller();scroller();",5);
}

function sizeRow(fields) {
    var tr = thetable.insertRow();
    for (var f in fields) {
        var field = fields[f];
        var td = tr.insertCell();
        if (field[1]!=-1) {
            td.setAttribute("width", field[1]+"px");
        }
    }
}

function createRow(record, fields, id) {
	var tr = thetable.insertRow();
	record.tr = tr;
	
	var twoRows = record["Description"]!=null;
	
    for (var f in fields) {
        var field = fields[f];

        var td = tr.insertCell();
        var text = record[field[0]];
	text = text?text:"";
        
        var crx = text.indexOf("\n");
        if (crx>0) {
            text = text.substring(0,crx);
        }
        
        td.innerText = text;

        if (field[2]!=null) {
            td.align = field[2];
        }

        td["className"] = "row notselected selectablerow "+record["severity"];
        if (twoRows) {
            td.style.paddingBottom = "0px";
        }
        td.onclick = function() { rowClick(id);};
    }
    
    if (twoRows) {
        var tr = thetable.insertRow();
        var td = tr.insertCell();
        td.colSpan = fields.length;
        td["className"] = "row selectablerow small "+record["severity"];
        var text = record["Description"];
        var crx = text.indexOf("\n");
        if (crx>0) {
            text = text.substring(0,crx);
        }
        
        td.innerText = text;
        td.style.paddingTop = "0px";
        td.onclick = function() { rowClick(id);};
    }
}

function calculateReminder(fields) {
    var tableWidth = document.getElementById("thetable").offsetWidth;
    var total = 0;
    for (var i=0;i<fields.length;++i) {
        total += fields[i][1]<=0?0:fields[i][1];
    }
    return tableWidth - total;
}

function rowClick(id) {
    if (id==null) { // group row
        status("group");
        return;
    }
    selectRow(thedata.rows[id].tr);
    flyout(thedata.type, thedata.rows[id]);
    document.focus();
}

function selectRow(tr) {
    if (tr==selectedTr) {
        return;
    }
    if (selectedTr!=null) {
        for (var i=0;i<selectedTr.childNodes.length;++i) {
            var cn = selectedTr.childNodes[i].className;
            selectedTr.childNodes[i].className = cn.replace("selected", "notselected");
        }
    }
    
    if (tr!=null) {
        for (var i=0;i<tr.childNodes.length;++i) {
            var cn = tr.childNodes[i].className;
            tr.childNodes[i].className = cn.replace("notselected", "selected");
        }
    }
    selectedTr = tr;
}

function doResize() {

    var s = sizes[giant()?1:0];
    var xx = ["width", "height"];
    
    var scroll = thetable.offsetHeight>s["thecontainer"]["height"];

    for (var p in s) {
        var t = document.getElementById(p);
        var ss = s[p];
        for (var x in xx) {
            x = xx[x];
            if (scroll) {
                var v = ss[x+"Scroll"]; 
                if (v) {
                    t.style[x] = v+"px";
                    continue;
                }
            }
            var v = ss[x]; 
            if (v) {
                t.style[x] = v+"px";
            }
        }
    }
    scroller(scroll);
}

function scroller(scroll) {
    if (scroll) {
        if (scrollbar==null) {
            scrollbar = new Scrollbar(thecontainer, thetable, scrollbarsite);
        } else {
            scrollbar.resize();
        }
    } else {
        if (scrollbar!=null) {
            scrollbar.clear();               
            scrollbar = null;
        }
    }
}

